;;; cl-gi.asd --- System Definition for cl-gi.
;;
;; Copyright (C) 2010 Jan Moringen
;;
;; Author: Jan Moringen <jmoringe@techfak.uni-bielefeld.de>
;;
;; This Program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This Program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program. If not, see <http://www.gnu.org/licenses>.

(defpackage :cl-gi-system
  (:use
   :cl
   :asdf))

(in-package :cl-gi-system)

(defsystem :cl-gi
  :author      "Jan Moringen <jmoringe@techfak.uni-bielefeld.de>"
  :maintainer  "Jan Moringen <jmoringe@techfak.uni-bielefeld.de>"
  :version     "0.1.0"
  :license     "GPL3"
  :description "Common Lisp interface to GObject introspection with
code generation."
  :depends-on  (:alexandria
		:iterate
		:metabang-bind
		:split-sequence

		 :s-xml

		 :cffi

		 :cl-gtk2-glib)
  :components  ((:module     "src"
		 :components ((:file       "package")
			      (:file       "model"
			       :depends-on ("package"))

			      (:module     "repository"
			       :depends-on ("package")
			       :components ((:file       "package")
					    (:file       "util"
					     :depends-on ("package"))
					    (:file       "protocol"
					     :depends-on ("package"))
					    (:file       "xml"
					     :depends-on ("package" "util"))))

			      (:module     "emitter"
			       :depends-on ("package" "model")
			       :components ((:file       "package")
					    (:file       "protocol"
					     :depends-on ("package"))
					    (:file       "context"
					     :depends-on ("package"))
					    (:file       "macros"
					     :depends-on ("package" "context"))
					    (:file       "generic"
					     :depends-on ("package" "protocol"
							  "context"))
					    (:file       "gobject-cffi"
					     :depends-on ("package" "protocol"
							  "context" "generic"))))))))
