;;; macros.lisp --- Macros for Writing Emitters.
;;
;; Copyright (C) 2010 Jan Moringen
;;
;; Author: Jan Moringen <jmoringe@techfak.uni-bielefeld.de>
;;
;; This Program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This Program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program. If not, see <http://www.gnu.org/licenses>.

(in-package :gir.emitter)

(defmacro with-emitter-symbols (&body body)
  "Augment the lexical scope with useful symbols for `emit' methods."
  `(flet ((push-package (name)
	    (push-package *context* name))
	  (pop-package ()
	    (pop-package *context*))
	  (recur (node)
	    (emit node (context-target *context*))))
     (declare (ignorable (function push-package)
			 (function pop-package)
			 (function recur)))
     (symbol-macrolet
	 ((target  (context-target  *context*))
	  (stack   (context-stack   *context*))
	  (package (current-package *context*)))
       ,@body)))
