;;; protocol.lisp ---
;;
;; Copyright (C) 2010 Jan Moringen
;;
;; Author: Jan Moringen <jmoringe@techfak.uni-bielefeld.de>
;;
;; This Program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This Program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program. If not, see <http://www.gnu.org/licenses>.

(in-package :gir.emitter)


;;; Binding Generation Protocol
;;

(defun generate (element &optional (type :gobject-cffi))
  "Generate bindings for the introspection data contained in ELEMENT
using the binding definition method TYPE."
  (emit element type)
  ;nil
  )


;;; Emitter Protocol
;;

(defgeneric emit (element target)
  (:documentation
   "Emit code for the introspection element ELEMENT using the binding
generation method designated by the keyword TARGET."))
