;;; util.lisp ---
;;
;; Copyright (C) 2010 Jan Moringen
;;
;; Author: Jan Moringen <jmoringe@techfak.uni-bielefeld.de>
;;
;; This Program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This Program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program. If not, see <http://www.gnu.org/licenses>.


;;;
;;

(in-package :bind)

(defbinding-form (:attributes)
  `(let (,@(iter:iter (iter:for var iter:in variables)
		      (iter:collect
			  `(,(if (listp var) (first var) var)
			     (s-xml:xml-element-attribute
			      ,values
			      ,(cond
				((and (listp var) (symbolp (second var)))
				 `(quote ,(second var)))
				((and (listp var) (listp (second var)))
				 (second var))
				(t `(quote ,var))))))))))
;;`(intern "type-name" :glib))))))))

;;(bind (((:attributes x (y z) (m (intern "u" :glib))) bla))
;;  x)


;;;
;;

;; in s-xml package?

(in-package :s-xml)

(defun xml-element-child (element name)
  "DOC"
  ;;(format t "~A~%" (xml-element-children element))
  (find name (xml-element-children element)
	:key #'xml-element-name :test #'string=))

(export 'xml-element-child)
